<?php

$num_posts = get_field('block_number_of_events');
$selected_posts = get_field('block_selected_events');
$organiser = get_field('block_event_organiser');

$events = get_posts(array(
    'post_type'         => 'event',
    'posts_per_page'    => $num_posts,
    'post__in'          => $selected_posts,
    'suppress_filters'  => false,
    'meta_query' 		=> array(
        'relation'  => 'AND',
        array(
            'key'       => 'event_status',
            'compare'   => '!=',
            'value'     => 'draft'
        ),
        array(
            'key'       => 'event_visibility',
            'compare'   => '=',
            'value'     => true
        ),
        array(
            'key'       => 'event_organiser',
            'compare'   => '=',
            'value'     => $organiser,
        ), 
    ),
)); 

if($events) { ?>

    <div class="posts-loop events custom-block">

        <?php
        $event_listings = array();

        foreach($events as $event) {

            $event_dates = get_field('event_series_dates', $event);
            if($event_dates) {

                $sorted_dates = array();
                foreach($event_dates as $event_date) {
                    
                    $start_date = $event_date['event_series_start_datetime'];
                    if(strtotime($start_date) >= strtotime("today")) {
                        $dateObject = new DateTime($start_date);
                        array_push($sorted_dates, $dateObject);
                    }
                    
                }

                if(count($sorted_dates) > 0) {
                    usort($sorted_dates, function ($a, $b) {
                        return $a->format('Y-m-d H:i:s') <=> $b->format('Y-m-d H:i:s');
                    });

                    $next_date = $sorted_dates[0]->format('Y-m-d H:i:s');

                    $ev = array(
                        'event_id'  => $event->ID,
                        'next_date' => $next_date,
                    );

                    array_push($event_listings, $ev);
                }
                
            }

        }

        if(count($event_listings) > 0) {

            // sort $event_listings by date order
            usort($event_listings, function ($a, $b) {
                return strtotime($a['next_date']) <=> strtotime($b['next_date']);
            });

            foreach($event_listings as $event_listing) {
                get_template_part( 'template-parts/events/event', 'preview', array(
                    'event_id'  => $event_listing['event_id'],
                    'next_date' => $event_listing['next_date'],
                ));
            }

        }
        ?>

    </div>
    
<?php } ?>