<?php
/**
 * Template Name: Whats On
 * 
 */

get_header();

$page_id = get_the_ID();
$organiser = get_field('page_event_organiser', $page_id);
$dates = $_GET['dates'] ?? null; ?>

<!-- <script type="text/javascript" src="https://cdn.jsdelivr.net/jquery/latest/jquery.min.js"></script> -->
<script type="text/javascript" src="https://cdn.jsdelivr.net/momentjs/latest/moment.min.js"></script>
<script type="text/javascript" src="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.min.js"></script>
<link rel="stylesheet" type="text/css" href="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.css" />

<main>

    <section id="ri-block-editor">
        <?php the_content(); ?>
    </section>

    <div class="container-wrap" id="events-search" >
        <div class="container">

            <form id="search-form">
                <div class="search-name">
                    <input type="text" name="q" id="event-name" placeholder="Search for Events" />
                    <ion-icon name="search-outline"></ion-icon>
                </div>
            
                <div class="search-dates">
                    <div id="preset-dates">
                        <span>
                            <input type="radio" name="date" id="hidden" value="all">
                            <input type="radio" id="all" name="date" value="all" checked>
                            <label class="date-label" for="all">All</label>
                        </span>
                        <span>
                            <input type="radio" id="today" name="date" value="today">
                            <label class="date-label" for="today">Today</label>
                        </span>
                        <span>
                            <input type="radio" id="week" name="date" value="week">
                            <label class="date-label" for="week">This Week</label>
                        </span>
                        <span>
                            <input type="radio" id="month" name="date" value="month">
                            <label class="date-label" for="month">This Month</label>
                        </span>
                    </div>

                    <div class="date-range">
                        <label for="datepicker" >or choose date: &nbsp;</label>
                        <!-- <span id="picker-clear" class="hide">x clear</span> -->
                        <input type="text" name="date_range" id="datepicker" />
                    </div>
                </div>

            </form>

        </div>

    </div>

    <?php // event grid
    $events = null; ?>

    <section class="container-wrap event-listing">
        <div class="container posts-loop events" id="event-listings"></div>
        <div id="grid-overlay">
            <div class="loader"></div>
        </div>
    </section>

    <section class="container-wrap gift-cards">
        <div class="container">
            <h2>Gift Cards</h2>
            <p>You can now gift a voucher for Real Ideas ticketed events, workshops and immersive experiences. Once purchased, the recipient can simply use the unique code at checkout when booking via the whats on page or Eventbrite.</p>
            <p>This can be redeemed against 1 ticket per transaction, any remaining balance can be used in future transactions. This is not for any co-work or meeting room purchases.</p>
            <div class="giftcards">
                <button type="button" class="btn" id="load-giftup">Buy Gift Cards</button>
            </div>
        </div>
    </section>

</main>

<script>

    const datesRadioForm = document.getElementById('preset-dates');
    const dateRangePicker = document.getElementById('datepicker');

    function getEvents(dateFilter, dateRange, title) {

        const loader = document.getElementById('grid-overlay');
        loader.style.display = 'block';

        const eventListings = document.getElementById('event-listings');
        eventListings.innerHTML = '';

        var ajaxurl = <?php echo json_encode(admin_url('admin-ajax.php')); ?>;
        nonce = <?php echo json_encode(wp_create_nonce('get_events_for_display_nonce')); ?>;

        // const datesRadioForm = document.getElementById('preset-dates');
        if(!dateFilter) {
            // console.log(dateFilter);
            const radioAll = document.querySelector('input[value="all"]');
            radioAll.checked = true;
        }

        jQuery.ajax({
            type: "post",
            dataType: "json",
            url: ajaxurl,
            data: {
                action: 'get_events_for_display',
                nonce: nonce,
                organiser: '<?php echo $organiser; ?>',
                dateFilter: dateFilter,
                dateRange: JSON.stringify(dateRange),
                title: title,
            },
            success: function(response) {

                if(response) {

                    response.forEach(item => {

                        const newItem = document.createElement('article');
                        newItem.className = 'event-preview';

                        var multipleDates = '';
                        if(item.is_series == 1) {
                            multipleDates = '<span>Multiple Dates</span>';
                        }

                        const html = `
                            <div class="inner">
                                <div class="featured-img">
                                    <img class="featured" src="${item.image}" alt="${item.title}" />
                                    <span class="img-overlay"></span>
                                    <a href="${item.link}"></a>
                                </div>
                            </div>
                            <div class="content">
                                ${multipleDates}
                                <span class="date">Next: ${item.next_date}</span>
                                <span class="time"> ${item.next_time}</span>
                                <h1> ${item.title}</h1>
                                <p> ${item.summary}</p>   
                                <a class="btn btn__link" href="${item.link}"><span class="btn__text">Book now</span></a>
                            </div>
                        `;
                        
                        newItem.innerHTML = html;
                        eventListings.appendChild(newItem);

                    });

                    setTimeout(function() {
                        eventListings.style.height = 'auto';
                        loader.style.display = 'none';
                    }, 200);

                }

            }
        });

    }

    datesRadioForm.addEventListener('change', function() {

        const eventListing = document.getElementById('event-listings');
        var listingHeight = eventListing.offsetHeight;
        eventListing.style.height = listingHeight + 'px';

        const radioButtons = document.querySelectorAll('input[name="date"]');
        radioButtons.forEach(function(radioButton) {
            if (radioButton.checked) {
                const selectedValue = radioButton.value;
                getEvents(selectedValue);
            }
        });

    });

    jQuery('input#datepicker').daterangepicker({
        "locale": {
            "format": "DD/MM/YYYY",
        }
    }, function(start, end, label) {

        const radioHidden = document.querySelector('input[name="date"]#hidden');
        radioHidden.checked = true;

        // console.log('New date range selected: ' + start.format('YYYY-MM-DD') + ' to ' + end.format('YYYY-MM-DD') + ' (predefined range: ' + label + ')');
        var dateRange = {
            'start': start.format('YYYY-MM-DD'),
            'end': end.format('YYYY-MM-DD'),
        }
        getEvents(null, dateRange);
    });

    var presetDateFilter = '<?php echo $dates; ?>';
    getEvents(presetDateFilter);

</script>

<?php get_footer(); ?>